package ru.mai.dep806.mvcapp.dao;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Repository;
import ru.mai.dep806.mvcapp.ApplicationException;
import ru.mai.dep806.mvcapp.model.User;

import javax.naming.InitialContext;
import javax.sql.DataSource;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.SQLException;

/**
 * Created with IntelliJ IDEA.
 * User: Eugene
 * Date: 27.10.12
 * Time: 12:59
 * To change this template use File | Settings | File Templates.
 */
@Repository
public class UserDao {

    @Autowired
    private JdbcTemplate jdbcTemplate;

    public void insertUser(User user) {
        int rowsAffected = jdbcTemplate.update(
                "INSERT INTO USERS(ID, LOGIN, NAME, PASSWORD) values (SEQ_ID.nextval,?,?,?)",
                user.getLogin(), user.getName(), user.getPasswordHash());

        if (rowsAffected != 1) {
            throw new ApplicationException("User was not saved");
        }
    }

    public void updateUser(User user) {

    }

//    public void insertUser(User user) {
//        long start = System.currentTimeMillis();
//        Connection connection = null;
//        PreparedStatement stmt = null;
//        try {
////            Class.forName("oracle.jdbc.OracleDriver");
////            connection = DriverManager.getConnection("jdbc:oracle:thin:@localhost:1521:ORCL", "mvcapp", "mvcapp");
//
////            InitialContext context = new InitialContext();
////            DataSource dataSource = (DataSource) context.lookup("java:/comp/env/jdbc/mvcds");
////            connection = dataSource.getConnection();
//
//            stmt = connection.prepareStatement("INSERT INTO USERS(ID, LOGIN, NAME, PASSWORD) " +
//                    "values (SEQ_ID.nextval,?,?,?)");
//            stmt.setString(1, user.getLogin());
//            stmt.setString(2, user.getName());
//            stmt.setString(3, user.getPasswordHash());
//
//            int rows = stmt.executeUpdate();
//            if (rows != 1) {
//                throw new ApplicationException("User was not saved");
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//        } finally {
//            if (stmt != null)  {
//                try { stmt.close(); } catch (SQLException e) {e.printStackTrace();}
//            }
//            if (connection != null) {
//                try { connection.close(); } catch (SQLException e) {e.printStackTrace();}
//            }
//        }
//        System.out.println("insertUser took: " + (System.currentTimeMillis() - start));
//    }
}
