package ru.mai.dep806.mvcapp.util;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

public class CryptoUtil {

    public static String digestPassword(String password) {
        System.out.println(password);
        try {
            byte[] digest = getDigest(password.getBytes("UTF-8"), "MD5");
            byte[] encoded = Base64.encode(digest);
            return new String(encoded);
        } catch (Exception e) {
            throw new RuntimeException("Cannot encode password", e);
        }
    }

    public static byte[] getDigest(byte[] message, String algorithm)
            throws NoSuchAlgorithmException {
        MessageDigest md = MessageDigest.getInstance(algorithm);
        return md.digest(message);
    }

    public static void main(String[] argv) {
        if (argv.length >= 1) {
            System.out.println(argv[0] + ": " + digestPassword(argv[0]));
        }
    }

}

